--Meader Tactics--
--Install and Update Manager--

--Notes--
--Managing all DBs.. adding new content without destroying user setting and messages

local install
local installMeaderDB
local installSetting
local installOptions
local init
local updateCheck
local updateHandler = {}
local versionDB
local meaderDB
local setting
local meaderDB

--Global function lib
meaderInstall = {}




-- Define throwaway tables
local tempTable = { [1] = {}, [2] = {} }  --Remember to allways do tempTable = {} before, and preferable after, using it.

init = function()
	versionDB = meaderTacticsVersionDB
	meaderDB = meaderTacticsDB
	setting = meaderTacticsSetting
	optionsDB = meaderTacticsOptions
end--init
meaderInstall.init = init


installMeaderDB = function()
meaderDB = {
	["difficulty"] = {
		{ ID = 1, name = "Normal" }, -- [1]
		{ ID = 2, name = "Heroic" }, -- [2]
		{ ID = 3, name = "Mythic" }, -- [3]
	},
	["boss"] = {
		{
			["ID"] = 1,
			["order"] = 1,
			["description"] = "",
			["parentID"] = 1,
			["encounterID"] = 1128,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Kargath Bladefist",
		}, -- [1]
		{
			["ID"] = 2,
			["order"] = 2,
			["description"] = "",
			["parentID"] = 1,
			["encounterID"] = 971,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "The Butcher",
		}, -- [2]
		{
			["ID"] = 3,
			["order"] = 3,
			["description"] = "",
			["parentID"] = 1,
			["encounterID"] = 1196,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Brackenspore",
		}, -- [3]
		{
			["ID"] = 4,
			["order"] = 4,
			["description"] = "",
			["parentID"] = 1,
			["encounterID"] = 1195,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Tectus",
		}, -- [4]
		{
			["ID"] = 5,
			["order"] = 5,
			["description"] = "",
			["parentID"] = 1,
			["encounterID"] = 1148,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Twin Orgon",
		}, -- [5]
		{
			["ID"] = 6,
			["order"] = 6,
			["description"] = "",
			["parentID"] = 1,
			["encounterID"] = 1153,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Ko'ragh",
		}, -- [6]
		{
			["ID"] = 7,
			["order"] = 7,
			["description"] = "",
			["parentID"] = 1,
			["encounterID"] = 1197,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Imperator Mar'gok",
		}, -- [7]
		{
			["ID"] = 8,
			["order"] = 1,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Oregorger",
		}, -- [8]
		{
			["ID"] = 9,
			["order"] = 2,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Gruul",
		}, -- [9]
		{
			["ID"] = 10,
			["order"] = 3,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Blast Furnace",
		}, -- [10]
		{
			["ID"] = 11,
			["order"] = 4,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Hans'gar and Franzok",
		}, -- [11]
		{
			["ID"] = 12,
			["order"] = 5,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Flamebender Ka'graz",
		}, -- [12]
		{
			["ID"] = 13,
			["order"] = 6,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Kromog",
		}, -- [13]
		{
			["ID"] = 14,
			["order"] = 7,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Beastlord Darmac",
		}, -- [14]
		{
			["ID"] = 15,
			["order"] = 8,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Operator Thogar",
		}, -- [15]
		{
			["ID"] = 16,
			["order"] = 9,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Iron Maidens",
		}, -- [16]
		{
			["ID"] = 17,
			["order"] = 10,
			["description"] = "",
			["parentID"] = 2,
			["encounterID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["name"] = "Blackhand",
		}, -- [17]
	},
	["message"] = {
		{
			["ID"] = 1,
			["name"] = "Please edit before using...",
			["difficultyID"] = 1,
			["order"] = 1,
			["parentID"] = 1,
			["channel"] = "RAID",
		}, -- [1]
	},
	["raid"] = {
		{
			["ID"] = 1,
			["expansion"] = 6,
			["name"] = "Highmaul",
			["order"] = 1,
			["instanceID"] = 477,
			["journalLink"] = "",
			["icon"] = "",
			["description"] = "",
		}, -- [1]
		{
			["ID"] = 2,
			["expansion"] = 6,
			["name"] = "Blackrock Foundry",
			["order"] = 2,
			["instanceID"] = 457,
			["journalLink"] = "",
			["icon"] = "",
			["description"] = "",
		}, -- [2]		
		{
			["ID"] = 3,
			["expansion"] = 6,
			["name"] = "Hellfire Citadel",
			["order"] = 3,
			["instanceID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["description"] = "",
		}, -- [3]
	},
--[[ Removed for now. To be developed at a later stage.
	["expansion"] = {
		"Classic", -- [1]
		"The Burning Crusades", -- [2]
		"Wrath of the Lich King", -- [3]
		"Cataclysm", -- [4]
		"Mists of Pandaria", -- [5]
		"Warlords of Draenor", -- [6]
	}
--]]
}

	meaderTacticsDB = meaderDB
end -- installMeaderDB
meaderInstall.meaderDB = installMeaderDB

installSetting = function()
setting = {
		["buttonHeight"] = 30,
		["currentDifficultyID"] = 1,
		["mainFrameX"] = 0,
		["editPanelPointA"] = "CENTER",
		["editPanelPointX"] = 50,
		--["buttonTemplate"] = "MeaderTacticsButtonTemplate", --"UIMenuButtonStretchTemplate", 
		["mainFrameY"] = 0,
		["editPanelPointY"] = 50,
		["buttonWidth"] = 200,
		["editPanelHeight"] = 150,
		["editPanelWidth"] = 300,
		["mainFrameA"] = "CENTER",
		["editBoxHeight"] = 150,
		["editBoxWidth"] = 300,
		["buttonTemplate"] = "MeaderTacticsButtonTemplate",  --"UIMenuButtonStretchTemplate",
		["editPanelBackdropBgFile"] = "Interface\DialogFrame\UI-DialogBox-Background-Dark",
		["editPanelEdgeFile"] = "Interface\DialogFrame\UI-DialogBox-Border",
---New since 0.6.2
		["buttonGrowthDirection"] = 1, ---- minus 1 for left, plus 1 for right!
		["worldMarkers"] = {[8] = "{Skull}", [7] = "{Cross}", [6] = "{Square}", [2] = "{Circle}", [1] = "{Star}", [4] = "{Triangle}", [3] = "{Diamond}", [5] = "{Moon}"},
		["optionsPanelPointA"] = "CENTER",
		["optionsPanelPointX"] = 0,
		["optionsPanelPointY"] = 0,
		["optionsPanelWidth"] = 400,
		["optionsPanelHeight"] = 500,
		["currentRaidID"] = 0,
		["smallButtonTemplate"] = "MeaderTacticsButtonTemplateSmall",
			
	}--end of setting def
		meaderTacticsSetting = setting

end--installSetting
meaderInstall.setting = installSetting

installOptions = function()
	tabDB = {
		[1] = {ID = 1, name = "Visuals", text = "Visuals", order=1},
		[2] = {ID = 2, name = "ImportExport", text = "Import/Export", order=2},
		[3] = {ID = 3, name = "FAQ", text = "FAQ", order=3},
		[4] = {ID = 4, name = "About", text = "About", order=4},

	}--end of tabID def
	optionDB = {
		[1] = {
			ID = 1,
			name="buttonTemplate",
			tabID = 1,
			order = 1,
			header = "Button text size",
			text = "Change the text size for the raid, boss and message buttons.",
			optionType = "radiobutton",
			tooltipID = 0,
			valueID = 2,
			defaultValueID = 2,
			maxValue = 3,
			minValue=1,
			hidden = false
			},
		[2] = {
			ID = 2,
			name="buttonGrowthDirection",
			tabID = 1,
			order = 2,
			header = "Button growth direction",
			text = "Set what direction the boss and message buttons pops out from the raid buttons.",
			optionType = "radiobutton",
			tooltipID = 0,
			valueID = 5,
			defaultValue = 4,
			maxValue = 2,
			minValue = 1,
			hidden = false
			},
		[3] = {
			ID = 3,
			name="authorName",
			tabID = 4,
			order = 1,
			header = "Author",
			text = "Meadermad - Earthen Ring (EU)",
			optionType = "text",
			tooltipID = 0,
			valueID = 0,
			defaultValue = 0,
			maxValue = 0,
			minValue = 0,
			hidden = false
			},
		[4] = {
			ID = 4,
			name="contactInfoTwitter",
			tabID = 4,
			order = 2,
			header = "Contact me on twitter",
			text = "@meadermad",
			optionType = "text",
			tooltipID = 0,
			valueID = 0,
			defaultValue = 0,
			maxValue = 0,
			minValue = 0,
			hidden = false
			},
		[5] = {
			ID = 5,
			name="contactInfoEmail",
			tabID = 4,
			order = 3,
			header = "Contact me by e-mail",
			text = "meadermad@gmail.com",
			optionType = "text",
			tooltipID = 0,
			valueID = 0,
			defaultValue = 0,
			maxValue = 0,
			minValue = 0,
			hidden = false
			},
		[6] = {
			ID = 6,
			name="projectSite",
			tabID = 4,
			order = 4,
			header = "Project Site",
			text = "http://wow.curseforge.com/addons/meader-tactics/ \n\nPlease submit any bug-reports, questions and comments here. All ideas for future development are welcome!",
			optionType = "text",
			tooltipID = 0,
			valueID = 0,
			defaultValue = 0,
			maxValue = 0,
			minValue = 0,
			hidden = false
			},
		[7] = {
			ID = 7,
			name="faq1",
			tabID = 3,
			order = 1,
			header = "How do I insert 'Dungeon Journal' links into messages?",
			text = "Open the dungeon journal and shift click the buttons there while you have the edit panel open, same as for sending links through chat.",
			optionType = "text",
			tooltipID = 0,
			valueID = 0,
			defaultValue = 0,
			maxValue = 0,
			minValue = 0,
			hidden = false
			},
		[8] = {
			ID = 8,
			name="faq2",
			tabID = 3,
			order = 2,
			header = "How do I delete or change names of tactic sets?",
			text = "You can't! At least for now. This is a planned feature for a future release (hopefully the next one).",
			optionType = "text",
			tooltipID = 0,
			valueID = 0,
			defaultValue = 0,
			maxValue = 0,
			minValue = 0,
			hidden = false
			},
		[9] = {
			ID = 9,
			name="faq3",
			tabID = 3,
			order = 3,
			header = "Any other questions?",
			text = "Ask them at curse:\nhttp://www.curse.com/addons/wow/meader-tactics",
			optionType = "text",
			tooltipID = 0,
			valueID = 0,
			defaultValue = 0,
			maxValue = 0,
			minValue = 0,
			hidden = false
			},

	}--end of optionDB def
	
	valueDB = {
		[1]={ID = 1, parentID = 1, name = "Small", text = "Small", value = "MeaderTacticsButtonTemplateSmall", order = 1, tooltipID = 0},
		[2]={ID = 2, parentID = 1, name = "Medium", text = "Medium", value = "MeaderTacticsButtonTemplate", order = 2, tooltipID = 0},
		[3]={ID = 3, parentID = 1, name = "Large", text = "Large", value = "MeaderTacticsButtonTemplateLarge", order = 3, tooltipID = 0},
		[4]={ID = 4, parentID = 2, name = "Left", text = "Left", value = -1, order = 1, tooltipID = 0},
		[5]={ID = 5, parentID = 2, name = "Right", text = "Right", value = 1, order = 2, tooltipID = 0},
	}--end of valueDB def
	
	tooltipDB = {
		[1] = {ID = 2, parentID = 0, parentType = "", text = "", order = 1}
	}--end of tooltipDB def
	
	meaderTacticsOptions = {["tabDB"] = tabDB,["optionDB"] = optionDB, ["valueDB"] = valueDB, ["tooltipDB"] = tooltipDB}
end--installOptions
meaderInstall.options = installOptions



updateHandlerInit = function ()
	init()
	for id, val in ipairs(versionDB) do
		if not versionDB[id]["installed"] then
			updateHandler[versionDB[id]["handler"]]()
		end--if installed
	end--for
end--updateHandlerInit
meaderInstall.updateHandlerInit = updateHandlerInit

updateCheck = function()
	for id, val in ipairs(meaderTacticsVersionDB) do
		if not meaderTacticsVersionDB[id]["installed"] then return false end
	end
	return true
end--updateCheck
meaderInstall.updateCheck = updateCheck

updateHandler.handler2 = function() --Update Handler for 0.6.2
	--Add ID field to all DB arrays. For raid and boss tables change ID to instanceID and encounterID to avoid a messup
	print("Meader Tactics: Updating the database")
	for k, v in pairs(meaderDB) do
--print("Update: "..k.."...")
		for k2, v2 in ipairs(meaderDB[k]) do
			if k == "raid" then 
				meaderDB["raid"][k2]["instanceID"] = meaderDB["raid"][k2]["ID"]
				meaderDB[k][k2]["ID"] = k2
--print("raid:"..k2)
			elseif k == "boss" then
				meaderDB["boss"][k2]["encounterID"] = meaderDB["boss"][k2]["ID"]
				meaderDB[k][k2]["ID"] = k2
--print("boss:"..k2)
			elseif k == "message" then
				meaderDB[k][k2]["ID"] = k2
				meaderDB[k][k2]["channel"] = "RAID"
--print("message:"..k2)
			elseif k == "difficulty" then
				meaderDB["difficulty"][k2] = {ID = k2, name = v2}
--print("difficulty:"..k2)
			elseif k == "expansion" then
				meaderDB["expansion"][k2] = { ID = k2, name = v2 }
			end
		end--for2
	end--for meaderDB
	meaderDB["raid"][3] = {
			["ID"] = 3,
			["expansion"] = 6,
			["name"] = "Hellfire Citadel",
			["order"] = 3,
			["instanceID"] = 0,
			["journalLink"] = "",
			["icon"] = "",
			["description"] = "",
		}
	-- Add to setting
	meaderTacticsSetting["buttonGrowthDirection"] = 1 ---- minus 1 for left, plus 1 for right!
	meaderTacticsSetting["optionsPanelPointA"] = "CENTER"
	meaderTacticsSetting["optionsPanelPointX"] = 0
	meaderTacticsSetting["optionsPanelPointY"] = 0
	meaderTacticsSetting["optionsPanelWidth"] = 400
	meaderTacticsSetting["optionsPanelHeight"] = 500
	meaderTacticsSetting["sendToChannels"] = nil
	meaderTacticsSetting["diffDropdownButtonTemplate"] = nil
	meaderTacticsSetting["buttonTemplate"] = "MeaderTacticsButtonTemplate"
	meaderTacticsSetting["worldMarkers"] = {[8] = "{Skull}", [7] = "{Cross}", [6] = "{Square}", [2] = "{Circle}", [1] = "{Star}", [4] = "{Triangle}", [3] = "{Diamond}", [5] = "{Moon}"}
	meaderTacticsSetting["currentRaidID"] = 0
	meaderTacticsSetting["smallButtonTemplate"] = "MeaderTacticsButtonTemplateSmall"
	
	versionDB[2]["installed"] = true
	
	meaderFrame.alertBox("Welcome to Meader Tactics 0.6.2!\n\nTo open the new options panel use:\n\n'/mead opt'\n\nTo toggle test mode use:\n\n'/mead test'\n\n In test mode messages will be sent to 'say' instead of 'raid chat'.\n\nFor more details on changes in this version please check out the project page at\n\nhttp://wow.curseforge.com/addons/meader-tactics/\n\nThere you can also report bugs and post your ideas for future development!\n\nHappy raiding and good luck!", false)

end--updateHandler.handler2

install = function(firstInstall)
	versionDB = {
		[1] = { ID=1, name = "0.6.1", handler = nil, installed = true },
		[2] = { ID=2, name = "0.6.2", handler = "handler2", installed = false },
	}
	if firstInstall then versionDB[2]["installed"] = true end
	
	meaderTacticsVersionDB = versionDB
end
meaderInstall.install = install
