
--------------------------------------
----  M e a d e r  T a c t i c s  ----
--------------------------------------
--[[
* Created by: meadermad at gmail dot com
* Submit bug reports by e-mail or at http://wow.curseforge.com/addons/meader-tactics/tickets/
* Version: 0.6.2.1
* Updated: 01.05.2015
Are you tired of PUG-raids where no one knows the tactics ant you are the one that has to type your fingers sore to explain it all? Then this is the addon for you! Explain the fights with just a few clicks...

For more information see ReadMe.txt or go to http://wow.curseforge.com/addons/meader-tactics/

--]]

-----------------------------
---- I N I T I A L I Z E ----
-----------------------------

-- A few variables used by many functions
local difficultyID = 1
local editMode = false
local testMode = false
local firstInstall = false
--etc

--Set the main object 'f'. Used for frames and functions
local f = {}
local meaderDB
local setting

--Definge the array to store each button. Sorted into three tables one for each level of buttons. A raid button is referred to as 'f.button["raid"][order]' where order is the number of buttons from top and down.
f.button = { ["raid"] = {},["boss"] = {},["message"] = {} }
f.eButton = { [1] = {},[2] = {},[3] = {}, [4] = {}, [5] = {} } --Encounter buttons
local linkHookTemplates={
  ["EncounterInstanceButtonTemplate"]=true,
  ["EncounterBossButtonTemplate"]=true,
  ["EncounterItemTemplate"]=true,
  ["EncounterInfoTemplate"]=true,
}

--Create the main frame
f.frame = CreateFrame("Frame", "MeaderTactics_MainFrame", UIParent) 
f.mainFrameDefined = false

-- Define throwaway tables
local tempTable = { [1] = {}, [2] = {} }  --Remember to allways do tempTable = {} before, and preferable after, using it.
local tempNewMessage = {}

--Predefine functions
local init
local mainFrame
local mainFrameButtons
local listButtons
local createButton
local hideButtons
local hideButtonsLoop
local printMessages
local createEditPanelFrame
local sortMessages
local countMessages
local deleteMessage
local moveMessage
local createDifficultyDropDown
local addNewDifficulty
local savePositions
local editPanelHelper
local getLink
local meaderLinkHook
--local listEncounterButtons
--local createEncounterButton
local showTooltip
local alertBox

-- Define the global that will hold any function, variable or table that is needed accross files
_G["meaderFrame"] = {}

---------------------------
---- F U N C T I O N S ----
---------------------------

init = function()
	--Load saved variables into the local DB
	meaderDB = meaderTacticsDB
	setting = meaderTacticsSetting
	difficultyID = setting.currentDifficultyID
end -- init

mainFrame = function()
		if f.mainFrameDefined == true then
	   		f.frame:SetPoint(setting.mainFrameA, setting.mainFrameX, setting.mainFrameY)
	   		if testMode then
	   			f.header:SetText("Meader Tactics(TEST)")
	   		else
				f.header:SetText("Meader Tactics")
	   		end
	   		f.frame:Show()
			return
		end
		
		--Define the main frame
   		f.frame:SetMovable(true)
   		f.frame:EnableMouse(true)
   		f.frame:RegisterForDrag("LeftButton")
   		f.frame:SetScript("OnDragStart", f.frame.StartMoving)
   		f.frame:SetScript("OnDragStop", f.frame.StopMovingOrSizing)
   		f.frame:SetResizable(true)
   		f.frame:SetMinResize(100, 100)
   		f.frame:SetPoint(setting.mainFrameA, setting.mainFrameX, setting.mainFrameY)
   		f.frame:SetSize(200,50)
   		f.frame:SetFrameStrata("FULLSCREEN_DIALOG")
   		f.header = f.frame:CreateFontString()
		f.header:SetFont(STANDARD_TEXT_FONT,15, "OUTLINE")
		f.header:SetJustifyH("CENTER")
		f.header:SetPoint("TOPLEFT", f.frame,"TOPLEFT",0,0)
		f.header:SetSize(200,25)
		f.header:SetTextColor(1, 0.3, 0, 1)    --light blue for original buttons: (0, 0.6, 1, 1) ---nice orange:(0.9, 0.7, 0, 1)
	   	if testMode then
	   		f.header:SetText("Meader Tactics (TEST)")
	   	else
			f.header:SetText("Meader Tactics")
	   	end
	   	tinsert(UISpecialFrames, f.frame:GetName())
   		mainFrameButtons()
   		f.mainFrameDefined = true
   		--f.frame:SetScript("OnLoad", function(self) tinsert(UISpecialFrames, self:GetName()) end)
   		f.frame:SetScript("OnShow", function(self) PlaySound("igCharacterInfoOpen") end)
   		f.frame:SetScript("OnHide", function(self)
   			savePositions()
   			if f.editPanel and f.editPanel:IsShown() then f.editPanel:Hide() end
   			PlaySound("igCharacterInfoClose")
   		end)

end


mainFrameButtons = function()
	--[[ToolTip
	f.toolTip = CreateFrame("GameTooltip","meaderToolTip", f.frame, "GameTooltipTemplate")
	f.toolTip:SetOwner(f.frame, "ANCHOR_CURSOR")
	--]]

	--Close main frame button
	local closeButton = CreateFrame("Button", "MeaderTacticsCloseAllButton", f.frame, "UIPanelCloseButton")
   	closeButton:SetScript("OnClick", function(self)
         print("Go kill some bosses!")
         HideParentPanel(self)
    end)
   	closeButton:SetPoint("BOTTOMLEFT", -3, 0)
    f.closeButton = closeButton
    
   --Difficulty Button (shows a dropdown)
   local normalButton   
   normalButton = CreateFrame("Button", "MeaderTacticsDifficultyDropDownMenuButton", f.frame, setting.smallButtonTemplate)   
   normalButton:SetPoint("BOTTOMRIGHT", -50, 5)
   normalButton:SetHeight(20)
   normalButton:SetWidth(125)
   normalButton:SetText(meaderDB["difficulty"][difficultyID]["name"])
   f.difficultyButton = normalButton    

	f.difficultyDropDownFrame = CreateFrame("Frame", "meaderTacticts_difficultyDropDown", f.frame)
	f.difficultyDropDownFrame:SetPoint("TOPRIGHT", f.frame, "BOTTOMRIGHT", -50, 5)
	f.difficultyDropDownFrame:SetResizable(true)
   	f.difficultyDropDownFrame:SetMinResize(100, 100)
	f.difficultyDropDownFrame:SetSize(125,20*(#meaderDB["difficulty"]+3))
	--local texture = f.difficultyDropDownFrame:CreateTexture("ARTWORK")
	--texture:SetAllPoints()
	--texture:SetTexture(0,0,0,1)
	f.difficultyDropDownFrame.button = {}
   createDifficultyDropDown()
   f.difficultyDropDownFrame:Hide()
   
   normalButton:SetScript("OnClick", function(self)
         if f.difficultyDropDownFrame:IsShown() then
            f.difficultyDropDownFrame:Hide()
            listButtons("raid",0)
            self:UnlockHighlight()
         else
            f.difficultyDropDownFrame:Show()
            hideButtons("raid")
            self:LockHighlight()
         end
   end)
   normalButton:SetScript("OnEnter", function(self)
   		local line1 = "Change raid difficulty"
   		local line2 = "You can also create more sets,"
   		local line3 = "for different tactics."
		showTooltip(self, line1, line2)
   end)
   normalButton:SetScript("OnLeave", function(self) 
   		GameTooltip:Hide()
   end)

   
   -- EditMode button
   local editButton = CreateFrame("Button", "MeaderTacticsEditModeButton", f.frame, setting.smallButtonTemplate)--"UIPanelButtonTemplate")
   editButton:SetScript("OnClick", function(self)
         if editMode then
            editMode=false
            editButton:UnlockHighlight()
         else
            editMode=true
            editButton:LockHighlight()
         end
         listButtons("raid",0)
	end)
   
   editButton:SetPoint("BOTTOMRIGHT", 0, 5)
   editButton:SetHeight(20)
   editButton:SetWidth(50)
   editButton:SetText("Edit")
   if editMode then editButton:LockHighlight() else editButton:UnlockHighlight() end
   
   --ToolTip
   editButton:SetScript("OnEnter", function(self)
   		local line1
   		local line2
   		if editMode then line1="Edit mode is ON";line2="Click to enter normal mode." else line1="Edit mode is OFF";line2="Click to enter edit mode." end
		showTooltip(self, line1, line2)
   end)
   editButton:SetScript("OnLeave", function(self) 
   		GameTooltip:Hide()
   end)
   f.editButton = editButton
end -- mainFrameButtons

listButtons = function(tableName, parentID)
--DEBUG
--print ("listButtons tableName: "..tableName.." parentID: "..parentID)
--END DEBUG
	local prevOrder = 1
	local text = ""
	hideButtons(tableName) 
	for k,v in pairs(meaderDB[tableName]) do
		if tableName == "raid" then
			createButton(tableName, k, meaderDB[tableName][k]["order"], parentID, false)
		elseif tableName == "boss" and meaderDB[tableName][k]["parentID"] == parentID then
			createButton(tableName, k, meaderDB[tableName][k]["order"], parentID, false)		
		elseif tableName == "message" and meaderDB[tableName][k]["parentID"] == parentID and meaderDB[tableName][k]["difficultyID"] == difficultyID then
			createButton(tableName, k, meaderDB[tableName][k]["order"], parentID, false)
			prevOrder = prevOrder + 1
		end
	end
	if tableName == "message" then
		--Add a "Add new.." button at the bottom
		createButton(tableName, #meaderDB["message"]+1, prevOrder, parentID, true)
	end
end --listButtons

createButton = function(tableName, tableIndex, order, parentID, addNew)
	local buttonID = tableName..order
	local posY
	local text
	local shortText
	if tableName == "raid" then posY = 0 elseif tableName == "boss" then posY = (setting.buttonWidth)*setting.buttonGrowthDirection else posY = (2 * setting.buttonWidth)*setting.buttonGrowthDirection end
	
	
	if f.button[tableName][order] then
		f.button[tableName][order]:Show()
	else
		--Create a new button
		local buttonTemplate
		if tableName == "message" then buttonTemplate = setting.smallButtonTemplate else buttonTemplate = setting.buttonTemplate end
		f.button[tableName][order] = CreateFrame("Button", "MeaderTacticsButton"..buttonID, f.frame, buttonTemplate)
		f.button[tableName][order]:SetPoint("BOTTOMLEFT", posY, -(setting.buttonHeight * (order)))
		f.button[tableName][order]:SetSize(setting.buttonWidth, setting.buttonHeight)
		f.button[tableName][order]:Show()
	end

	if not addNew then
		text = meaderDB[tableName][tableIndex]["name"]
		if strlen(text) > 25 then shortText = strsub(text,1,25).."..." else shortText = text end
	else
		text = "Add new.."
		shortText = text
	end
	
	
	f.button[tableName][order]:SetText(shortText)
	f.button[tableName][order]:UnlockHighlight()
	f.button[tableName][order]:SetScript("OnEnter", function(self) end)
   	f.button[tableName][order]:SetScript("OnLeave", function(self) end)
	
	if tableName == "raid" then
		f.button[tableName][order]:SetScript("OnClick", function(self, button, down)
			unlockButtonsLoop("raid")
			self:LockHighlight()
			setting.currentRaidID = tableIndex
			listButtons("boss", tableIndex)
		end)
	elseif tableName == "boss" and editMode then
		f.button[tableName][order]:SetScript("OnClick", function(self, button, down)
			unlockButtonsLoop("boss")
			self:LockHighlight()
			listButtons("message", tableIndex)
		end)
	elseif tableName == "boss" and not editMode then
		f.button[tableName][order]:SetScript("OnClick", function(self, button, down)
			printMessages(tableIndex)
		end)
		if testMode then
   			f.button[tableName][order]:SetScript("OnEnter", function(self)
   				local line1 = "TEST MODE IS ON"
   				local line2 = "Your messages will only be sent to 'say'"
   				local line3 = "You can turn off testmode with:"
   				local line4 = "'/mead test'"
				showTooltip(self, line1, line2, line3, line4)
   			end)
   			f.button[tableName][order]:SetScript("OnLeave", function(self) 
   				GameTooltip:Hide()
   			end)
		end		
	elseif tableName == "message" and editMode then
		f.button[tableName][order]:SetScript("OnClick", function(self, button, down)
			unlockButtonsLoop("message")
			self:LockHighlight()
			createEditPanelFrame(tableIndex, text, order, parentID, addNew)
		end)	
	end
end --createButton

createDifficultyDropDown = function()
	local pos = 1
	for k,v in ipairs(meaderDB["difficulty"]) do
		if not f.difficultyDropDownFrame.button[pos] then
			--Create a new button
			f.difficultyDropDownFrame.button[pos] = CreateFrame("Button", "MeaderTacticsDifficultyDropDownOptionButton"..pos, f.difficultyDropDownFrame, setting.smallButtonTemplate)
			f.difficultyDropDownFrame.button[pos]:SetPoint("TOPLEFT", 0, -(pos*20)+20)
			f.difficultyDropDownFrame.button[pos]:SetSize(125,20)
		else
			f.difficultyDropDownFrame.button[pos]:Show()
		end
		f.difficultyDropDownFrame.button[pos]:SetText(meaderDB["difficulty"][k]["name"])
		f.difficultyDropDownFrame.button[pos]:SetScript("OnClick", function(self)
			difficultyID = k
			--hideButtons("message")
			listButtons("raid",0)
			f.difficultyButton:SetText(meaderDB["difficulty"][k]["name"])
			f.difficultyButton:UnlockHighlight()
			f.difficultyDropDownFrame:Hide()
		end)
		pos = pos + 1
	end--for
	-- Add a "Add new" button at the end of the dropdown
	if not f.difficultyDropDownFrame.button[pos] then
		--Create a new button
		f.difficultyDropDownFrame.button[pos] = CreateFrame("Button", "MeaderTacticsDifficultyDropDownOptionButton"..pos, f.difficultyDropDownFrame, setting.smallButtonTemplate)
		f.difficultyDropDownFrame.button[pos]:SetPoint("TOPLEFT", 0, -(pos*20)+20)
		f.difficultyDropDownFrame.button[pos]:SetSize(130,20)
	else
		f.difficultyDropDownFrame.button[pos]:Show()
	end
	f.difficultyDropDownFrame.button[pos]:SetText("Add new")
	f.difficultyDropDownFrame.button[pos]:SetScript("OnClick", function(self)
		--print("Add new difficulty will be developed later on...")
		addNewDifficulty(pos)
	end)

end--createDifficultyDropDown

addNewDifficulty = function(pos)
	if not f.addNewDifficulty then
		f.addNewDifficulty = CreateFrame("EditBox", "MeaderTacticsAddNewDifficultyEditBox", f.frame, "InputBoxTemplate")
		f.addNewDifficulty:SetPoint("TOPLEFT",f.difficultyDropDownFrame,"TOPLEFT", 0, -((pos+1)*20)+20)
		f.addNewDifficulty:SetSize(125, 30)
	else
		f.addNewDifficulty:Show()
		f.addNewDifficulty:SetPoint("TOPLEFT",f.difficultyDropDownFrame,"TOPLEFT", 0, -((pos+1)*20)+20)
	end
	f.addNewDifficulty:SetText("Tactic set title...")
	f.addNewDifficulty:SetScript("OnEnterPressed", function(self)
		meaderDB["difficulty"][pos] = {["name"] = self:GetText(), ["ID"] = pos}
		createDifficultyDropDown()
		self:Hide()
	end)
	f.addNewDifficulty:SetScript("OnEscapePressed", function(self) self:Hide() end)

	
end--addNewDifficulty

hideButtons = function(cTable)
	if cTable == "raid" then hideButtonsLoop("message"); hideButtonsLoop("boss"); hideButtonsLoop("raid")
	elseif cTable == "boss" then hideButtonsLoop("message"); hideButtonsLoop("boss")
	elseif cTable == "message" then hideButtonsLoop("message")
	end
end --hideButtons


hideButtonsLoop = function(tableName)
	for k,v in pairs(f.button[tableName]) do
			f.button[tableName][k]:Hide()
	end
end -- hideButtonsLoop

unlockButtonsLoop = function(tableName)
	for k,v in pairs(f.button[tableName]) do
		f.button[tableName][k]:UnlockHighlight()
	end
end --unlockButtonsLoop

printMessages = function(tableIndex)
	--NOTES:  IsInRaid()
	sortedTable = sortMessages(tableIndex)
	for k,v in pairs(sortedTable) do
		if testMode then  --or not IsInGroup(LE_PARTY_CATEGORY_INSTANCE)
			SendChatMessage(meaderDB["message"][v]["name"] ,'SAY')
		else
			if UnitIsGroupLeader("player") or UnitIsRaidOfficer("player") or IsEveryoneAssistant() then
				SendChatMessage(meaderDB["message"][v]["name"] ,meaderDB["message"][v]["channel"])
			else
				SendChatMessage(meaderDB["message"][v]["name"] ,'RAID')
			end
		end
	end--for
end

sortMessages = function(tableIndex)
	tempTable[1] = {}
	for k,v in pairs(meaderDB["message"]) do
		if meaderDB["message"][k]["parentID"] == tableIndex and meaderDB["message"][k]["difficultyID"] == difficultyID then
			tempTable[1][meaderDB["message"][k]["order"]] = k
		end
	end--for
	return tempTable[1]
end--sortMessages

deleteMessage = function (tableIndex)
	--print("meader Tactics: Not yet implemented... Can't delete message #"..tableIndex)
	local order = meaderDB["message"][tableIndex]["order"]
	local parent = meaderDB["message"][tableIndex]["parentID"]
	local diff = meaderDB["message"][tableIndex]["difficultyID"]
	table.remove(meaderDB["message"], tableIndex)
	for k,v in pairs(meaderDB["message"]) do
		if meaderDB["message"][k]["order"] > order and meaderDB["message"][k]["parentID"]==parent and v["difficultyID"] == diff then
			meaderDB["message"][k]["order"] = meaderDB["message"][k]["order"]-1
		end
	end
	print("Meader Tactics: Deleted message #"..tableIndex.."")
end--deleteMessage

moveMessage = function (direction, tableIndex)
	local order = meaderDB["message"][tableIndex]["order"]
	local newOrder
	local target
	local parent = meaderDB["message"][tableIndex]["parentID"]
	
	if direction == "up" then
		newOrder = order-1
	elseif direction == "down" then
		newOrder = order+1
	end
	for k,v in pairs(meaderDB["message"]) do
		if (meaderDB["message"][k]["order"] == newOrder) and (meaderDB["message"][k]["parentID"] == parent) then --and (not k==tableIndex) then
			target = k
		end
	end
	meaderDB["message"][tableIndex]["order"] = newOrder
	meaderDB["message"][target]["order"] = order
end--moveMessage

countMessages = function (tableIndex)
	local cnt = 0
	for k,v in pairs(meaderDB["message"]) do
		if meaderDB["message"][k]["parentID"] == tableIndex and meaderDB["message"][k]["difficultyID"] == difficultyID then cnt = cnt +1 end
	end
	return cnt
end--countMessages

savePositions = function()
	if f.editPanel then
	local point, relativeTo, relativePoint, xOffset, yOffset = f.editPanel:GetPoint(1)
	setting.editPanelPointY = yOffset
	setting.editPanelPointX = xOffset
	setting.editPanelPointA = point
	end
	if f.frame then
	local point, relativeTo, relativePoint, xOffset, yOffset = f.frame:GetPoint(1)
	setting.mainFrameA = point
	setting.mainFrameX = xOffset
	setting.mainFrameY = yOffset
	end
	setting.currentDifficultyID = difficultyID
	
end--savePositions


-----------------
---- TOOLTIP ----
-----------------

--[[ Basic use:
   f:SetScript("OnEnter", function(self)
   		local line1 = "title in gold"
   		local line2 = "second line in white"
		showTooltip(self, line1, line2)
   end)
   f:SetScript("OnLeave", function(self) 
   		GameTooltip:Hide()
   end)
--]]
showTooltip = function(self, ...)
	local line1, line2, line3, line4, line5, line6, line7, line8, line9 = ...
   	GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
 	GameTooltip:SetText(line1)
 	if line2 then GameTooltip:AddLine(line2, 1,1,1) end
 	if line3 then GameTooltip:AddLine(line3, 1,1,1) end
 	if line4 then GameTooltip:AddLine(line4, 1,1,1) end
 	if line5 then GameTooltip:AddLine(line5, 1,1,1) end
 	if line6 then GameTooltip:AddLine(line6, 1,1,1) end
 	if line7 then GameTooltip:AddLine(line7, 1,1,1) end
 	if line8 then GameTooltip:AddLine(line8, 1,1,1) end
 	if line9 then GameTooltip:AddLine(line9, 1,1,1) end
 	GameTooltip:Show()

end--showTooltip


----------------------------
---- E D I T  P A N E L ----
----------------------------

createEditPanelFrame = function(tableIndex, text, order, parentID, addNew)
	tempNewMessage = {}
	if not f.editPanel then
		f.editPanel = CreateFrame("Frame", "MeaderTacticsEditPanelMainFrame", f.frame)
		f.editPanel:SetSize(setting.editPanelWidth, setting.editPanelHeight)
		f.editPanel:SetPoint(setting.editPanelPointA, UIParent,setting.editPanelPointA, setting.editPanelPointX, setting.editPanelPointY)
		f.editPanel:SetMovable(true)
   		f.editPanel:EnableMouse(true)
   		f.editPanel:RegisterForDrag("LeftButton")
   		f.editPanel:SetScript("OnDragStart", f.editPanel.StartMoving)
   		f.editPanel:SetScript("OnDragStop", f.editPanel.StopMovingOrSizing)
   		f.editPanel:SetScript("OnHide", function(self) savePositions() end)

		--header
		local header = f.editPanel:CreateFontString()
		header:SetFont(STANDARD_TEXT_FONT,12, "OUTLINE")
		header:SetJustifyH("CENTER")
		header:SetPoint("TOP", f.editPanel,"TOP", 0, 15)
		header:SetWidth(setting.editPanelWidth)
		header:SetTextColor(1, 0.3, 0, 1) --MeaderRed
		header:SetText("Meader Tactics Edit Panel")

		local texture = f.editPanel:CreateTexture("BACKGROUND")
		texture:SetAllPoints()
		texture:SetTexture(0,0,0,0)
		local backdrop = {
  			bgFile = "Interface/DialogFrame/UI-DialogBox-Background", --setting.editPanelBackdropBgFile,  
  			edgeFile = "Interface/Tooltips/UI-Tooltip-Border", --setting.editPanelEdgeFile,
  			tile = true,
  			tileSize = 32,
  			edgeSize = 15,
  			insets = {
    			left = 4,
    			right = 4,
    			top = 3,
    			bottom = 3
  			}
		}--]]
		f.editPanel:SetBackdrop(backdrop)
		--f.editPanel:SetBackdropColor(0,0,0,1)
	else
		f.editPanel:Show()
	end

	if not f.editBox then
   		f.editBox = CreateFrame("EditBox", "MeaderTacticsEditBox", f.editPanel) --, "InputBoxTemplate") --"InputScrollFrameTemplate")
   		f.editBox:SetHeight(150)
   		f.editBox:SetWidth(300)
   		f.editBox:SetPoint("TOPLEFT", f.editPanel, "TOPLEFT", 0, 0)
   		f.editBox:SetMaxLetters(255)
   		f.editBox:SetMultiLine(true)
		f.editBox:SetTextInsets(20, 20, 20, 20)   
		f.editBox:SetTextColor(1, 1, 1, 1) 
   		f.editBox:EnableKeyboard(true)
   		f.editBox:SetFontObject(GameFontNormal)
   		f.editBox:SetAutoFocus(false)
   		f.editBox:SetFocus()

    else
   		f.editBox:Show()
    end
   	--Edit box scripts
   	f.editBox:SetScript("OnChar",function(self,userInput,...)
      	local text = self:GetText() or ""
	  	self: SetText(text)--..""..userInput)
	end)
	if addNew then
   		f.editBox:SetScript( "OnEnterPressed", function (self) 
   			meaderDB["message"][tableIndex] = {name=f.editBox:GetText(),difficultyID=difficultyID,order=order,parentID=parentID}
   			if tempNewMessage["channel"] then 
   					meaderDB["message"][tableIndex]["channel"] = tempNewMessage["channel"]
   			else
   				meaderDB["message"][tableIndex]["channel"] = "RAID"
   			end
   			tempNewMessage = {}		
   			hideButtons("message")
   			listButtons("message", parentID)
   			f.editPanel:Hide()
   		end)
	else
   		f.editBox:SetScript( "OnEnterPressed", function (self) 
   			meaderDB["message"][tableIndex]["name"] = self:GetText()
   			hideButtons("message")
   			listButtons("message", parentID)
   			f.editPanel:Hide()   		
   		end)
   	end
   	f.editBox:SetScript( "OnEscapePressed", function (self)
   		f.editBox:ClearFocus()
   		--f.editPanel:Hide()
   	end)
   	
 	f.editBox:SetText(text)
   	f.editBox:SetFocus()
   						  
	if not f.cancelButton then
   		f.cancelButton = CreateFrame("Button", "MeaderTactics_cancelMessage", f.editPanel, setting.smallButtonTemplate)
   		f.cancelButton:SetPoint("BOTTOMRIGHT", f.editPanel, "BOTTOMRIGHT", -5, 5)
   		f.cancelButton:SetSize(48,25)
   		f.cancelButton:SetText("Cancel")
   		f.cancelButton:SetScript("OnClick", function(self)
   		f.editPanel:Hide()
		end)
	else
		f.cancelButton:Show()
	end
	
	if not f.saveButton then
		f.saveButton = CreateFrame("Button", "MeaderTactics_saveMessage", f.editPanel, setting.smallButtonTemplate)
   		f.saveButton:SetPoint("BOTTOMRIGHT", f.editPanel, "BOTTOMRIGHT", -53.5, 5)
   		f.saveButton:SetSize(48,25)
   		f.saveButton:SetText("Save")
	else
		f.saveButton:Show()
	end
	if addNew then
   		f.saveButton:SetScript( "OnClick", function (self) 
   			meaderDB["message"][tableIndex] = {name=f.editBox:GetText(),difficultyID=difficultyID,order=order,parentID=parentID}
   			if tempNewMessage["channel"] then 
   					meaderDB["message"][tableIndex]["channel"] = tempNewMessage["channel"]
   			else
   				meaderDB["message"][tableIndex]["channel"] = "RAID"
   			end
   			tempNewMessage = {}  			
   			hideButtons("message")
   			listButtons("message", parentID)
   			f.editPanel:Hide()
   		end)
	else
   		f.saveButton:SetScript( "OnClick", function (self) 
   			meaderDB["message"][tableIndex]["name"] = f.editBox:GetText()
   			hideButtons("message")
   			listButtons("message", parentID)
   			f.editPanel:Hide()   		
   		end)
   	end

	if not f.deleteButton then
		f.deleteButton = CreateFrame("Button", "MeaderTacticsDeleteMessageButton", f.editPanel, setting.smallButtonTemplate)
   		f.deleteButton:SetPoint("BOTTOMRIGHT", f.editPanel, "BOTTOMRIGHT", -102, 5)
   		f.deleteButton:SetSize(48,25)
   		f.deleteButton:SetText("Delete")
   	else
   		f.deleteButton:Show()
   	end
   		f.deleteButton:SetScript( "OnClick", function (self) 
			deleteMessage(tableIndex)
   			hideButtons("message")
   			listButtons("message", parentID)
   			f.editPanel:Hide()
   		end)
   	if addNew or #meaderDB["message"] < 2 then f.deleteButton:Hide() end 

	if not f.moveUpButton then
		f.moveUpButton = CreateFrame("Button", "MeaderTacticsMoveMessageUpButton", f.editPanel, setting.smallButtonTemplate)
   		f.moveUpButton:SetPoint("BOTTOMRIGHT", f.editPanel, "BOTTOMRIGHT", -150, 5)
   		f.moveUpButton:SetSize(48,25)
   		f.moveUpButton:SetText("Up")
   	else
   		f.moveUpButton:Show()
   	end
   	f.moveUpButton:SetScript( "OnClick", function (self) 
		moveMessage("up", tableIndex)
   		hideButtons("message")
   		listButtons("message", parentID)
   		f.editPanel:Hide()
   	end)
   	f.moveUpButton:SetScript("OnEnter", function(self)
   		local line1 = "Move message up"
   		showTooltip(self, line1)
   	end)
   	f.moveUpButton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
   	if order==1 or addNew then f.moveUpButton:Hide() end
   	

	if not f.moveDownButton then
		f.moveDownButton = CreateFrame("Button", "MeaderTacticsMoveMessageDownButton", f.editPanel, setting.smallButtonTemplate)
   		f.moveDownButton:SetPoint("BOTTOMRIGHT", f.editPanel, "BOTTOMRIGHT", -198.5, 5)
   		f.moveDownButton:SetSize(48,25)
   		f.moveDownButton:SetText("Down")
   	else
   		f.moveDownButton:Show()
   	end
   	f.moveDownButton:SetScript( "OnClick", function (self) 
			moveMessage("down", tableIndex)
   			hideButtons("message")
   			listButtons("message", parentID)
   			f.editPanel:Hide()
   		end)
   	f.moveDownButton:SetScript("OnEnter", function(self)
   		local line1 = "Move message down"
   		showTooltip(self, line1)
   	end)
   	f.moveDownButton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
   	if order >= countMessages(parentID) or addNew then f.moveDownButton:Hide() end
	
	--Initiate the helper panel
	editPanelHelper(tableIndex, meaderDB["boss"][parentID]["ID"], addNew)
	f.editPanelHelper:Hide()
	
   	if not f.moreButton then
   		f.moreButton = CreateFrame("Button", "MeaderTacticsEditPanelHelperButton", f.editPanel, setting.smallButtonTemplate)
   		f.moreButton:SetPoint("BOTTOMLEFT", f.editPanel, "BOTTOMLEFT", 5, 5)
		f.moreButton:SetSize(49,25)
		f.moreButton:SetText("More")
	else
		f.moreButton:Show()
	end
	if f.editPanelHelper:IsShown() then f.moreButton:LockHighlight() else f.moreButton:UnlockHighlight() end
	
	f.moreButton:SetScript("OnClick", function(self)
		if f.editPanelHelper:IsShown() then
			f.editPanelHelper:Hide()
			self:UnlockHighlight()
		else
			f.editPanelHelper:Show()
			self:LockHighlight()
		end
	end)
	f.moreButton:SetScript("OnEnter", function(self)
   		local line1
   		local line2
   		if f.editPanelHelper:IsShown() then
   			line1 = "Hide helper"
			showTooltip(self, line1)
   		else
   			line1 = "Show helper window"
   			line2 = "A tool to insert raid markers"
   			line3 = "and links for abilities and endcounters"
			showTooltip(self, line1, line2, line3)
   		end
   end)
   f.moreButton:SetScript("OnLeave", function(self) 
   		GameTooltip:Hide()
   end)

	
end--createEditPanelFrame

---------------------------
---- EDIT PANEL HELPER ----
---------------------------
editPanelHelper = function(messageID, encounterID, addNew)
	local height = 10
	if not f.editPanelHelper then
		f.editPanelHelper = CreateFrame("Frame", "MeaderTacticsEditPanelMainFrame", f.editPanel)
		f.editPanelHelper:SetSize(setting.editPanelWidth, setting.editPanelHeight)
		f.editPanelHelper:SetPoint("TOPLEFT", f.editPanel, "BOTTOMLEFT", 0,-5)
		f.editPanelHelper:SetMovable(true)
   		f.editPanelHelper:EnableMouse(true)
   		f.editPanelHelper:RegisterForDrag("LeftButton")
   		f.editPanelHelper:SetScript("OnDragStart", f.editPanel.StartMoving)
   		f.editPanelHelper:SetScript("OnDragStop", f.editPanel.StopMovingOrSizing)
		local texture = f.editPanelHelper:CreateTexture("BACKGROUND")
		texture:SetAllPoints()
		texture:SetTexture(0,0,0,0)
		local backdrop = {
  			bgFile = "Interface/DialogFrame/UI-DialogBox-Background", --setting.editPanelBackdropBgFile,  
  			edgeFile = "Interface/Tooltips/UI-Tooltip-Border", --setting.editPanelEdgeFile,
  			tile = true,
  			tileSize = 32,
  			edgeSize = 15,
  			insets = {
    			left = 4,
    			right = 4,
    			top = 3,
    			bottom = 3
  			}
		}--]]
		f.editPanelHelper:SetBackdrop(backdrop)
		--f.editPanel:SetBackdropColor(0,0,0,1)
		
	end
		f.editPanelHelper:SetPoint("TOPLEFT", f.editPanel, "BOTTOMLEFT", 0,-5)
	
	-- World Marker Buttons
	if not f.editPanelWorldMarkers then
		f.editPanelWorldMarkers = {}
		
		--header
		local header = f.editPanelHelper:CreateFontString()
		header:SetFont(STANDARD_TEXT_FONT,12, "OUTLINE")
		header:SetJustifyH("LEFT")
		header:SetPoint("TOPLEFT", f.editPanelHelper,"TOPLEFT", 10, -height)
		header:SetWidth(setting.editPanelWidth-20)
		header:SetTextColor(1, 0.3, 0, 1) --MeaderRed
		header:SetText("Insert World Markers")
		height = height + header:GetStringHeight() + 5
		
		--The buttons
		local pos = 0
		for k,v in pairs(setting.worldMarkers) do
			f.editPanelWorldMarkers[k] = CreateFrame("Button", "MeaderTacticsWorldMarkerButton_"..k, f.editPanelHelper, setting.buttonTemplate)
			f.editPanelWorldMarkers[k]:SetSize(25,25)
			f.editPanelWorldMarkers[k]:SetPoint("TOPLEFT",5+(pos*30)+5,-height)
			f.editPanelWorldMarkers[k]:SetNormalTexture("Interface/TargetingFrame/UI-RaidTargetingIcon_"..k)
			f.editPanelWorldMarkers[k]:SetScript("OnClick", function(self) f.editBox:Insert(v)end)
	   		f.editPanelWorldMarkers[k]:SetScript("OnEnter", function(self)
   				local line1 = "Insert "..setting.worldMarkers[k].." raid marker"
				showTooltip(self, line1)
   			end)
   			f.editPanelWorldMarkers[k]:SetScript("OnLeave", function(self) 
   				GameTooltip:Hide()
   			end)

			pos = pos + 1
		end--for
		height = height + 35
	end--if

	-- Channel Options: RAID
	if not f.editPanelChannelOptionRaid then
		--header
		local header = f.editPanelHelper:CreateFontString()
		header:SetFont(STANDARD_TEXT_FONT,12, "OUTLINE")
		header:SetJustifyH("LEFT")
		header:SetPoint("TOPLEFT", f.editPanelHelper,"TOPLEFT", 10, -height)
		header:SetWidth(setting.editPanelWidth-20)
		header:SetTextColor(1, 0.3, 0, 1) --MeaderRed
		header:SetText("Select chat channel")
		height = height + header:GetStringHeight() + 5
	
		f.editPanelChannelOptionRaid = CreateFrame("CheckButton", "EditPanelHelperChannelOptionRaid", f.editPanelHelper, "UIRadioButtonTemplate")
		_G[f.editPanelChannelOptionRaid:GetName() .. "Text"]:SetText("Raid")
		f.editPanelChannelOptionRaid:SetHeight(20)
		f.editPanelChannelOptionRaid:SetWidth(20)
		f.editPanelChannelOptionRaid:SetPoint("TOPLEFT", f.editPanelHelper, "TOPLEFT", 10, -height)
	end--if not channel options

	if addNew or meaderDB["message"][messageID]["channel"] == "RAID" then
		f.editPanelChannelOptionRaid:SetChecked(true)
	else
		f.editPanelChannelOptionRaid:SetChecked(false)
	end
			
	if not addNew then
		f.editPanelChannelOptionRaid:SetScript("OnClick", function(self)
			if self:GetChecked() then
				--self:SetChecked(true)
				f.editPanelChannelOptionRaidWarning:SetChecked(false)
				meaderDB["message"][messageID]["channel"] = "RAID"
			end
		end)
	else
		f.editPanelChannelOptionRaid:SetScript("OnClick", function(self)
			if self:GetChecked() then
				--self:SetChecked(true)
				f.editPanelChannelOptionRaidWarning:SetChecked(false)
				tempNewMessage["channel"] = "RAID"
			end
		end)
	end
	
		-- Channel Options: RAID_WARNING
	if not f.editPanelChannelOptionRaidWarning then
		f.editPanelChannelOptionRaidWarning = CreateFrame("CheckButton", "EditPanelHelperChannelOptionRaidWarning", f.editPanelHelper, "UIRadioButtonTemplate")
		_G[f.editPanelChannelOptionRaidWarning:GetName() .. "Text"]:SetText("Raid Warning")
		f.editPanelChannelOptionRaidWarning:SetHeight(20)
		f.editPanelChannelOptionRaidWarning:SetWidth(20)
		f.editPanelChannelOptionRaidWarning:SetPoint("TOPLEFT", f.editPanelHelper, "TOPLEFT", 150, -height)
	end--if not channel options

	if not addNew then
		if meaderDB["message"][messageID]["channel"] == "RAID_WARNING" then
		f.editPanelChannelOptionRaidWarning:SetChecked(true)
		else
			f.editPanelChannelOptionRaidWarning:SetChecked(false)
		end
	else
		f.editPanelChannelOptionRaidWarning:SetChecked(false)
	end
			
	if not addNew then
		f.editPanelChannelOptionRaidWarning:SetScript("OnClick", function(self)
			if self:GetChecked() then
				--self:SetChecked(true)
				f.editPanelChannelOptionRaid:SetChecked(false)
				meaderDB["message"][messageID]["channel"] = "RAID_WARNING"
			end
		end)
	else
		f.editPanelChannelOptionRaidWarning:SetScript("OnClick", function(self)
			if self:GetChecked() then
				--self:SetChecked(true)
				f.editPanelChannelOptionRaid:SetChecked(false)
				tempNewMessage["channel"] = "RAID_WARNING"
			end
		end)
	end
	height = height + 30


--[[ REMOVED UNTIL FURTHER DEVELOPMENT....
	--Encounter Link Browser Button
	if encounterID then --This is needed as the BRF bosses don't have encounterIDs
		local name, description, eencounterID, firstSection, encounterLink = EJ_GetEncounterInfo(encounterID)
		if not f.encounterButton then
			f.encounterButton = CreateFrame("Button", "MeaderTacticsWorldMarkerButton_1", f.editPanelHelper, setting.buttonTemplate)
			f.encounterButton:SetSize(100,20)
			f.encounterButton:SetPoint("TOPLEFT",10, -80)
			f.encounterButton:RegisterForClicks("LeftButtonUp","RightButtonUp")
			--f.editPanelWorldMarkers[1]:SetNormalTexture("Interface/TargetingFrame/UI-RaidTargetingIcon_"..k)
		end
		f.encounterButton:SetText(name)
		f.encounterButton:SetScript("OnClick", function(self, button, down)
			if button == "LeftButton" then
				--listEncounterButtons(firstSection, 1)
			else
				f.editBox:Insert(encounterLink)
			end
		end)
		f.encounterButton:SetScript("OnEnter", function(self)
   			local line1 = "Journal link to "..name
   			local line2 = "Left mouse button to browse more links (To be developed)."
   			local line3 = "Right mouse button to insert link."
			showTooltip(self, line1, line2, line3)
   		end)
   		f.encounterButton:SetScript("OnLeave", function(self) 
   			GameTooltip:Hide()
   		end)
	end--if encounter id
--]]
end--editPanelHelper


---- Encounter Link Browser ----
-- REMOVED FOR NOW
--[[
listEncounterButtons = function(sectionID, lvl)
	local pos = 1
	while sectionID do
		local name, description, headerType, abilityIcon, displayInfo, siblingID, nextSectionID, fileredByDifficulty, sectionLink, startsOpen, flag1, flag2, flag3, flag4 = EJ_GetSectionInfo(sectionID)
		createEncounterButton(name, abilityIcon, sectionLink, nextSectionID, lvl, pos)
		pos = pos + 1
		if pos > 20 then sectionID=false else sectionID = siblingID end
		
	end
end--listEncounterButtons

createEncounterButton = function(name, abilityIcon, sectionLink, nextSectionID, lvl, pos)
	
	if not f.eButton[lvl][pos] then
		f.eButton[lvl][pos] = CreateFrame("Button", "MeaderTactsEncounterLinkBrowserButton"..lvl.."-"..pos, f.editPanelHelper, "UIMenuButtonStretchTemplate")
		f.eButton[lvl][pos]:SetPoint("TOPLEFT", -55+(lvl*100)-100,-10+(pos*20)-20)
		f.eButton[lvl][pos]:SetSize(100,20)
		f.eButton[lvl][pos]:RegisterForClicks("LeftButtonUp","RightButtonUp")
	end
	f.eButton[lvl][pos]:SetText(name)
	f.eButton[lvl][pos]:SetScript("OnClick",function(self,button)
		if button == "LeftButton" then
			listEncounterButtons(nextSectionID, lvl+1)
		else
			f.editBox:Insert(sectionLink)
		end
	end)
	f.eButton[lvl][pos]:SetScript("OnEnter", function(self)
   		local line1 = "Jornal link to "..name
   		local line2 = "Left mouse button to browse more links."
   		local line3 = "Right mouse button to insert link."
		showTooltip(self, line1, line2, line3)
   end)
   f.eButton[lvl][pos]:SetScript("OnLeave", function(self) 
   		GameTooltip:Hide()
   end)
end--createEncounterButton
--]]

-- Link Hook Script --
--Script taken from: http://forums.curseforge.com/showthread.php?t=20622 bu user: Dridzt
getLink = function (self,button)
  if self.link and IsModifiedClick("CHATLINK") then
    -- do whatever with the link, example print it.
    if f.editBox:IsShown() then
    	f.editBox:Insert(self.link)
	    --print(self.link)
	end
  end
end

meaderLinkHook = function (ftype,fname,fparent,template)
  if template and linkHookTemplates[template] then
    if not fname then return end
    local button = _G[fname].button or _G[fname]
    if button and button:IsObjectType("Button") then
      if button.hooked then return end
      button:HookScript("OnClick",getLink)
      button.hooked = true
    end
  end
end
hooksecurefunc("CreateFrame", meaderLinkHook)


alertBox = function(text, showCancel, callbackConfirm, callbackCancel)
	if not f.alertBox then
		f.alertBox = CreateFrame("Frame", "MeaderTacticsEditPanelMainFrame", UIParent)
		f.alertBox:SetSize(meaderTacticsSetting.editPanelWidth+50, meaderTacticsSetting.editPanelHeight)
		f.alertBox:SetPoint("CENTER", UIParent, "CENTER", 0,0)
   		f.alertBox:SetFrameStrata("FULLSCREEN_DIALOG")
		local texture = f.alertBox:CreateTexture("BACKGROUND")
		texture:SetAllPoints()
		texture:SetTexture(0,0,0,0)
		local backdrop = {
  			bgFile = "Interface/DialogFrame/UI-DialogBox-Background", --setting.editPanelBackdropBgFile,  
  			edgeFile = "Interface/Tooltips/UI-Tooltip-Border", --setting.editPanelEdgeFile,
  			tile = true,
  			tileSize = 32,
  			edgeSize = 15,
  			insets = {
    			left = 4,
    			right = 4,
    			top = 3,
    			bottom = 3
  			}
		}--]]
		f.alertBox:SetBackdrop(backdrop)
		
		-- Header
		local header = f.alertBox:CreateFontString()
		header:SetFont(STANDARD_TEXT_FONT,18, "OUTLINE")
		header:SetJustifyH("CENTER")
		header:SetJustifyV("CENTER")
		header:SetPoint("TOP", f.alertBox,"TOP", 0, 25)
		header:SetSize(meaderTacticsSetting.editPanelWidth+50, 25)
		header:SetTextColor(1, 0.3, 0, 1)  --MeaderRed
		header:SetText("Meader Tactics")
		f.alertBoxHeader = header
		
		-- Text
		local text = f.alertBox:CreateFontString()
		text:SetFont(STANDARD_TEXT_FONT,14, "OUTLINE")
		text:SetPoint("TOP", f.alertBox,"TOP", 0, -15)
		text:SetWidth(meaderTacticsSetting.editPanelWidth+20)
		text:SetTextColor(1, 0.3, 0, 1)  --MeaderRed
		f.alertBoxText = text
		
		local confirmButton = CreateFrame("Button", "MeaderTacticsOptionPanelCancelButton", f.alertBox, meaderTacticsSetting.smallButtonTemplate)
   		confirmButton:SetPoint("BOTTOM", f.alertBox, "BOTTOM", -50, 10)
   		confirmButton:SetSize(75,25)
   		confirmButton:SetText("OK")

		f.alertBox.confirmButton = confirmButton
		
		local cancelButton = CreateFrame("Button", "MeaderTacticsOptionPanelCancelButton", f.alertBox, meaderTacticsSetting.smallButtonTemplate)
   		cancelButton:SetPoint("BOTTOM", f.alertBox, "BOTTOM", 50, 10)
   		cancelButton:SetSize(75,25)
   		cancelButton:SetText("Cancel")
		f.alertBox.cancelButton = cancelButton

	end
	
	f.alertBox.confirmButton:SetScript("OnClick", function(self)
   		if callbackConfirm then callbackConfirm() end
   		f.alertBox:Hide()
   		return true
	end)
	
	f.alertBox.cancelButton:SetScript("OnClick", function(self)
   		if callbackCancel then callbackCancel() end
   		f.alertBox:Hide()
   		return false
	end)	
		
	
	
	if showCancel then
		f.alertBox.cancelButton:Show()
		f.alertBox.confirmButton:SetPoint("BOTTOM", f.alertBox, "BOTTOM", -50, 10)
	else
		f.alertBox.cancelButton:Hide()
		f.alertBox.confirmButton:SetPoint("BOTTOM", f.alertBox, "BOTTOM", 0, 10)
	end
		f.alertBoxText:SetText(text)
		if f.alertBoxText:GetStringHeight() > meaderTacticsSetting.editPanelHeight-50 then f.alertBox:SetHeight(f.alertBoxText:GetStringHeight()+60) end
		f.alertBox:Show()
end--alertBox
meaderFrame.alertBox = alertBox



--------------------
-- EVENT HANDLERS --
--------------------
f.frame:RegisterEvent("ADDON_LOADED")
f.frame:SetScript("OnEvent",
   function(self, event, ...) 
      local arg = ...
      if event == "ADDON_LOADED" and arg == "MeaderTactics" then
         --Check if globals exist and load them
         DEFAULT_CHAT_FRAME:AddMessage("Meader Tactics loaded.\nTo open the raid selection window type '/mead'.\nFor options type '/mead opt'\nTo toggle test mode use '/mead test'.\nHappy raiding!", 1, 0.3, 0)
         
         --Check if the main DB is installed (Saved variable exists)
         
         if not _G["meaderTacticsSetting"] then
         	meaderInstall.setting()
         	firstInstall = true
         end
         
         if not _G["meaderTacticsDB"] then
            --Greet the user for the first time and copy the raid table into the global.
			alertBox("Welcome to Meader Tactics!\n\nType '/mead' in chat to get started \nor '/mead opt' to open the option panel.\n\nYour database of raids, bosses and tactics is empty. Please configure your tactics by entering edit mode by clicking 'Edit' in the main panel. First select the tactic set (Normal, Heroic...), then select a raid and boss and click 'Add new' and type the first message.\n\n Happy raiding and good luck!", false)
			meaderInstall.meaderDB()
         	firstInstall = true
         end
         

         
         if not _G["meaderTacticsOptions"] then
         	meaderInstall.options()
         end
         
         if not _G["meaderTacticsVersionDB"] then
         	meaderInstall.install(firstInstall)
         end
         
         -- Initialize the main tables (get them from saved variables)
         init()
         
         --Check if the saved variables are in tune with the current version of Meader Tactics.
         if not meaderInstall.updateCheck() and not firstInstall then
         	meaderInstall.updateHandlerInit()
         end
                   
      end--if addon loaded
	end)--event handler


--------------------
-- SLASH COMMANDS --
--------------------

--This command reinstalls the database. Use with care as it wipes all stored info.

SLASH_MEADERTACTICS1 = "/mead"
function SlashCmdList.MEADERTACTICS(...)
	arg1 = ...
	
	if arg1 == "test" then
		if testMode then testMode=false else testMode=true end
		mainFrame()
		listButtons("raid", 0)
	elseif arg1 == "options" or arg1=="opt" then
		meaderOptions.init()
	elseif arg1=="a" then
	alertBox("Welcome to Meader Tactics 0.6.2!\n\nTo open the new options panel use:\n\n'/mead opt'\n\nTo toggle test mode use:\n\n'/mead test'\n\n In test mode messages will be sent to 'say' instead of 'raid chat'.\n\nFor more details on changes in this version please check out the project page at\n\nhttp://wow.curseforge.com/addons/meader-tactics/\n\nThere you can also report bugs and post your ideas for future development!\n\nHappy raiding and good luck!", false)
	else
		mainFrame()
		listButtons("raid", 0)
		if setting.currentRaidID > 0 then
			listButtons("boss", setting.currentRaidID)
		end
	end
end